test 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683
  1. #!/usr/bin/env bash
  2. #
  3. # Run all etcd tests
  4. # ./test
  5. # ./test -v
  6. #
  7. #
  8. # Run specified test pass
  9. #
  10. # $ PASSES=unit ./test
  11. # $ PASSES=integration ./test
  12. #
  13. #
  14. # Run tests for one package
  15. # Each pass has different default timeout, if you just run tests in one package or 1 test case then you can set TIMEOUT
  16. # flag for different expectation
  17. #
  18. # $ PASSES=unit PKG=./wal TIMEOUT=1m ./test
  19. # $ PASSES=integration PKG=client/integration TIMEOUT=1m ./test
  20. #
  21. #
  22. # Run specified unit tests in one package
  23. # To run all the tests with prefix of "TestNew", set "TESTCASE=TestNew ";
  24. # to run only "TestNew", set "TESTCASE="\bTestNew\b""
  25. #
  26. # $ PASSES=unit PKG=./wal TESTCASE=TestNew TIMEOUT=1m ./test
  27. # $ PASSES=unit PKG=./wal TESTCASE="\bTestNew\b" TIMEOUT=1m ./test
  28. # $ PASSES=integration PKG=client/integration TESTCASE="\bTestV2NoRetryEOF\b" TIMEOUT=1m ./test
  29. #
  30. #
  31. # Run code coverage
  32. # COVERDIR must either be a absolute path or a relative path to the etcd root
  33. # $ COVERDIR=coverage PASSES="build_cov cov" ./test
  34. set -e
  35. source ./build
  36. # build before setting up test GOPATH
  37. if [[ "${PASSES}" == *"functional"* ]]; then
  38. ./functional/build
  39. fi
  40. if [ -z "$PASSES" ]; then
  41. PASSES="fmt bom dep build unit"
  42. fi
  43. USERPKG=${PKG:-}
  44. # Invoke ./tests/cover.test.bash for HTML output
  45. COVER=${COVER:-"-cover"}
  46. # Hack: gofmt ./ will recursively check the .git directory. So use *.go for gofmt.
  47. IGNORE_PKGS="(vendor/|etcdserverpb|rafttest|gopath.proto|v3lockpb|v3electionpb)"
  48. INTEGRATION_PKGS="(integration|tests/e2e|contrib|functional)"
  49. # all github.com/etcd-io/etcd/whatever pkgs that are not auto-generated / tools
  50. # shellcheck disable=SC1117
  51. PKGS=$(find . -name \*.go | while read -r a; do dirname "$a"; done | sort | uniq | grep -vE "$IGNORE_PKGS" | grep -vE "(tools/|contrib/|tests/e2e|pb)" | sed "s|\.|${REPO_PATH}|g" | xargs echo)
  52. # pkg1,pkg2,pkg3
  53. PKGS_COMMA=${PKGS// /,}
  54. # shellcheck disable=SC1117
  55. TEST_PKGS=$(find . -name \*_test.go | while read -r a; do dirname "$a"; done | sort | uniq | grep -vE "$IGNORE_PKGS" | sed "s|\./||g")
  56. # shellcheck disable=SC1117
  57. FORMATTABLE=$(find . -name \*.go | while read -r a; do echo "$(dirname "$a")/*.go"; done | sort | uniq | grep -vE "$IGNORE_PKGS" | sed "s|\./||g")
  58. TESTABLE_AND_FORMATTABLE=$(echo "$TEST_PKGS" | grep -vE "$INTEGRATION_PKGS")
  59. # check if user provided PKG override
  60. if [ -z "${USERPKG}" ]; then
  61. TEST=$TESTABLE_AND_FORMATTABLE
  62. FMT=$FORMATTABLE
  63. else
  64. # strip out leading dotslashes and trailing slashes from PKG=./foo/
  65. TEST=${USERPKG/#./}
  66. TEST=${TEST/#\//}
  67. TEST=${TEST/%\//}
  68. # only run gofmt on packages provided by user
  69. FMT="$TEST"
  70. fi
  71. # shellcheck disable=SC2206
  72. FMT=($FMT)
  73. if [ "${VERBOSE}" == "1" ]; then
  74. # shellcheck disable=SC2128
  75. echo "Running with FMT:" "${FMT[@]}"
  76. fi
  77. # prepend REPO_PATH to each local package
  78. split=$TEST
  79. TEST=""
  80. for a in $split; do TEST="$TEST ${REPO_PATH}/${a}"; done
  81. # shellcheck disable=SC2206
  82. TEST=($TEST)
  83. if [ "${VERBOSE}" == "1" ]; then
  84. # shellcheck disable=SC2128
  85. echo "Running with TEST:" "${TEST[@]}"
  86. fi
  87. # TODO: 'rafttest' is failing with unused
  88. STATIC_ANALYSIS_PATHS=$(find . -name \*.go ! -path './vendor/*' ! -path './gopath.proto/*' ! -path '*pb/*' | while read -r a; do dirname "$a"; done | sort | uniq | grep -vE "$IGNORE_PKGS")
  89. # shellcheck disable=SC2206
  90. STATIC_ANALYSIS_PATHS=($STATIC_ANALYSIS_PATHS)
  91. if [ "${VERBOSE}" == "1" ]; then
  92. # shellcheck disable=SC2128
  93. echo "Running with STATIC_ANALYSIS_PATHS:" "${STATIC_ANALYSIS_PATHS[@]}"
  94. fi
  95. if [ -z "$GOARCH" ]; then
  96. GOARCH=$(go env GOARCH);
  97. fi
  98. # determine the number of CPUs to use for Go tests
  99. TEST_CPUS="1,2,4"
  100. if [ -n "${CPU}" ]; then
  101. TEST_CPUS="${CPU}"
  102. fi
  103. echo "Running with TEST_CPUS:" "${TEST_CPUS}"
  104. # determine whether target supports race detection
  105. if [ "$GOARCH" == "amd64" ]; then
  106. RACE="--race"
  107. fi
  108. RUN_ARG=""
  109. if [ -n "${TESTCASE}" ]; then
  110. RUN_ARG="-run=${TESTCASE}"
  111. fi
  112. function unit_pass {
  113. echo "Running unit tests..."
  114. GO_TEST_FLAG=""
  115. if [ "${VERBOSE}" == "1" ]; then
  116. GO_TEST_FLAG="-v"
  117. fi
  118. if [ "${VERBOSE}" == "2" ]; then
  119. GO_TEST_FLAG="-v"
  120. export CLIENT_DEBUG=1
  121. fi
  122. if [ "${RUN_ARG}" == "" ]; then
  123. RUN_ARG="-run=Test"
  124. fi
  125. # check if user provided time out, especially useful when just run one test case
  126. # expectation could be different
  127. USERTIMEOUT=""
  128. if [ -z "${TIMEOUT}" ]; then
  129. USERTIMEOUT="30m"
  130. else
  131. USERTIMEOUT="${TIMEOUT}"
  132. fi
  133. go test ${GO_TEST_FLAG} -timeout "${USERTIMEOUT}" "${COVER}" ${RACE} -cpu "${TEST_CPUS}" ${RUN_ARG} "$@" "${TEST[@]}"
  134. }
  135. function integration_pass {
  136. echo "Running integration tests..."
  137. # check if user provided time out, especially useful when just run one test case
  138. # expectation could be different
  139. USERTIMEOUT=""
  140. if [ -z "${TIMEOUT}" ]; then
  141. USERTIMEOUT="30m"
  142. else
  143. USERTIMEOUT="${TIMEOUT}"
  144. fi
  145. # if TESTCASE and PKG set, run specified test case in specified PKG
  146. # if TESTCASE set, PKG not set, run specified test case in all integration and integration_extra packages
  147. # if TESTCASE not set, PKG set, run all test cases in specified package
  148. # if TESTCASE not set, PKG not set, run all tests in all integration and integration_extra packages
  149. if [ -z "${TESTCASE}" ] && [ -z "${USERPKG}" ]; then
  150. go test -timeout "${USERTIMEOUT}" -v -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/integration"
  151. integration_extra "$@"
  152. else
  153. if [ -z "${USERPKG}" ]; then
  154. INTEGTESTPKG=("${REPO_PATH}/integration"
  155. "${REPO_PATH}/client/integration"
  156. "${REPO_PATH}/clientv3/integration"
  157. "${REPO_PATH}/store")
  158. else
  159. INTEGTESTPKG=("${TEST[@]}")
  160. fi
  161. go test -timeout "${USERTIMEOUT}" -v -cpu "${TEST_CPUS}" "${RUN_ARG}" "$@" "${INTEGTESTPKG[@]}"
  162. fi
  163. }
  164. function integration_extra {
  165. go test -timeout 25m -v ${RACE} -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/clientv3/integration"
  166. go test -timeout 1m -v ${RACE} -cpu "${TEST_CPUS}" -run=Example "$@" "${TEST[@]}"
  167. }
  168. function functional_pass {
  169. # Clean up any data and logs from previous runs
  170. rm -rf /tmp/etcd-functional-* /tmp/etcd-functional-*.backup
  171. for a in 1 2 3; do
  172. ./bin/etcd-agent --network tcp --address 127.0.0.1:${a}9027 &
  173. pid="$!"
  174. agent_pids="${agent_pids} $pid"
  175. done
  176. for a in 1 2 3; do
  177. echo "Waiting for 'etcd-agent' on ${a}9027..."
  178. while ! nc -z localhost ${a}9027; do
  179. sleep 1
  180. done
  181. done
  182. echo "functional test START!"
  183. ./bin/etcd-tester --config ./functional.yaml && echo "'etcd-tester' succeeded"
  184. ETCD_TESTER_EXIT_CODE=$?
  185. echo "ETCD_TESTER_EXIT_CODE:" ${ETCD_TESTER_EXIT_CODE}
  186. # shellcheck disable=SC2206
  187. agent_pids=($agent_pids)
  188. kill -s TERM "${agent_pids[@]}" || true
  189. if [[ "${ETCD_TESTER_EXIT_CODE}" -ne "0" ]]; then
  190. printf "\n"
  191. echo "FAILED! 'tail -1000 /tmp/etcd-functional-1/etcd.log'"
  192. tail -1000 /tmp/etcd-functional-1/etcd.log
  193. printf "\n"
  194. echo "FAILED! 'tail -1000 /tmp/etcd-functional-2/etcd.log'"
  195. tail -1000 /tmp/etcd-functional-2/etcd.log
  196. printf "\n"
  197. echo "FAILED! 'tail -1000 /tmp/etcd-functional-3/etcd.log'"
  198. tail -1000 /tmp/etcd-functional-3/etcd.log
  199. echo "--- FAIL: exit code" ${ETCD_TESTER_EXIT_CODE}
  200. exit ${ETCD_TESTER_EXIT_CODE}
  201. fi
  202. echo "functional test PASS!"
  203. }
  204. function cov_pass {
  205. echo "Running code coverage..."
  206. # install gocovmerge before running code coverage from github.com/wadey/gocovmerge
  207. # gocovmerge merges coverage files
  208. if ! command -v gocovmerge >/dev/null; then
  209. echo "gocovmerge not installed"
  210. exit 255
  211. fi
  212. if [ -z "$COVERDIR" ]; then
  213. echo "COVERDIR undeclared"
  214. exit 255
  215. fi
  216. if [ ! -f "bin/etcd_test" ]; then
  217. echo "etcd_test binary not found"
  218. exit 255
  219. fi
  220. mkdir -p "$COVERDIR"
  221. # run code coverage for unit and integration tests
  222. GOCOVFLAGS="-covermode=set -coverpkg ${PKGS_COMMA} -v -timeout 30m"
  223. # shellcheck disable=SC2206
  224. GOCOVFLAGS=($GOCOVFLAGS)
  225. failed=""
  226. for t in $(echo "${TEST_PKGS}" | grep -vE "(tests/e2e|functional)"); do
  227. tf=$(echo "$t" | tr / _)
  228. # cache package compilation data for faster repeated builds
  229. go test "${GOCOVFLAGS[@]}" -i "${REPO_PATH}/$t" || true
  230. # uses -run=Test to skip examples because clientv3/ example tests will leak goroutines
  231. go test "${GOCOVFLAGS[@]}" -run=Test -coverprofile "$COVERDIR/${tf}.coverprofile" "${REPO_PATH}/$t" || failed="$failed $t"
  232. done
  233. # v2v3 tests
  234. go test -tags v2v3 "${GOCOVFLAGS[@]}" -coverprofile "$COVERDIR/store-v2v3.coverprofile" "${REPO_PATH}/clientv3/integration" || failed="$failed store-v2v3"
  235. # proxy tests
  236. go test -tags cluster_proxy "${GOCOVFLAGS[@]}" -coverprofile "$COVERDIR/proxy_integration.coverprofile" "${REPO_PATH}/integration" || failed="$failed proxy-integration"
  237. go test -tags cluster_proxy "${GOCOVFLAGS[@]}" -coverprofile "$COVERDIR/proxy_clientv3.coverprofile" "${REPO_PATH}/clientv3/integration" || failed="$failed proxy-clientv3/integration"
  238. # run code coverage for e2e tests
  239. # use 30m timeout because e2e coverage takes longer
  240. # due to many tests cause etcd process to wait
  241. # on leadership transfer timeout during gracefully shutdown
  242. echo Testing tests/e2e without proxy...
  243. go test -tags cov -timeout 30m -v "${REPO_PATH}/tests/e2e" || failed="$failed tests/e2e"
  244. echo Testing tests/e2e with proxy...
  245. go test -tags "cov cluster_proxy" -timeout 30m -v "${REPO_PATH}/tests/e2e" || failed="$failed tests/e2e-proxy"
  246. # incrementally merge to get coverage data even if some coverage files are corrupted
  247. # optimistically assume etcdserver package's coverage file is OK since gocovmerge
  248. # expects to start with a non-empty file
  249. cp "$COVERDIR"/etcdserver.coverprofile "$COVERDIR"/cover.out
  250. for f in "$COVERDIR"/*.coverprofile; do
  251. echo "merging test coverage file ${f}"
  252. gocovmerge "$f" "$COVERDIR"/cover.out >"$COVERDIR"/cover.tmp || failed="$failed $f"
  253. if [ -s "$COVERDIR"/cover.tmp ]; then
  254. mv "$COVERDIR"/cover.tmp "$COVERDIR"/cover.out
  255. fi
  256. done
  257. # strip out generated files (using GNU-style sed)
  258. sed --in-place '/generated.go/d' "$COVERDIR"/cover.out || true
  259. # held failures to generate the full coverage file, now fail
  260. if [ -n "$failed" ]; then
  261. for f in $failed; do
  262. echo "--- FAIL:" "$f"
  263. done
  264. exit 255
  265. fi
  266. }
  267. function e2e_pass {
  268. echo "Running e2e tests..."
  269. # check if user provided time out, especially useful when just run one test case
  270. # expectation could be different
  271. USERTIMEOUT=""
  272. if [ -z "${TIMEOUT}" ]; then
  273. USERTIMEOUT="30m"
  274. else
  275. USERTIMEOUT="${TIMEOUT}"
  276. fi
  277. go test -timeout "${USERTIMEOUT}" -v -cpu "${TEST_CPUS}" "${RUN_ARG}" "$@" "${REPO_PATH}/tests/e2e"
  278. }
  279. function integration_e2e_pass {
  280. echo "Running integration and e2e tests..."
  281. go test -timeout 30m -v -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/tests/e2e" &
  282. e2epid="$!"
  283. go test -timeout 30m -v -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/integration" &
  284. intpid="$!"
  285. wait $e2epid
  286. wait $intpid
  287. integration_extra "$@"
  288. }
  289. function grpcproxy_pass {
  290. go test -timeout 30m -v ${RACE} -tags cluster_proxy -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/integration"
  291. go test -timeout 30m -v ${RACE} -tags cluster_proxy -cpu "${TEST_CPUS}" "$@" "${REPO_PATH}/clientv3/integration"
  292. go test -timeout 30m -v -tags cluster_proxy "$@" "${REPO_PATH}/tests/e2e"
  293. }
  294. function release_pass {
  295. rm -f ./bin/etcd-last-release
  296. # to grab latest patch release; bump this up for every minor release
  297. UPGRADE_VER=$(git tag -l --sort=-version:refname "v3.3.*" | head -1)
  298. if [ -n "$MANUAL_VER" ]; then
  299. # in case, we need to test against different version
  300. UPGRADE_VER=$MANUAL_VER
  301. fi
  302. if [[ -z ${UPGRADE_VER} ]]; then
  303. UPGRADE_VER="v3.3.0"
  304. echo "fallback to" ${UPGRADE_VER}
  305. fi
  306. local file="etcd-$UPGRADE_VER-linux-$GOARCH.tar.gz"
  307. echo "Downloading $file"
  308. set +e
  309. curl --fail -L "https://github.com/etcd-io/etcd/releases/download/$UPGRADE_VER/$file" -o "/tmp/$file"
  310. local result=$?
  311. set -e
  312. case $result in
  313. 0) ;;
  314. *) echo "--- FAIL:" ${result}
  315. exit $result
  316. ;;
  317. esac
  318. tar xzvf "/tmp/$file" -C /tmp/ --strip-components=1
  319. mkdir -p ./bin
  320. mv /tmp/etcd ./bin/etcd-last-release
  321. }
  322. function shellcheck_pass {
  323. if command -v shellcheck >/dev/null; then
  324. shellcheckResult=$(shellcheck -fgcc build test scripts/*.sh 2>&1 || true)
  325. if [ -n "${shellcheckResult}" ]; then
  326. echo -e "shellcheck checking failed:\\n${shellcheckResult}"
  327. exit 255
  328. fi
  329. fi
  330. }
  331. function markdown_you_pass {
  332. # eschew you
  333. yous=$(find . -name \*.md ! -path './vendor/*' ! -path './Documentation/v2/*' ! -path './gopath.proto/*' -exec grep -E --color "[Yy]ou[r]?[ '.,;]" {} + || true)
  334. if [ -n "$yous" ]; then
  335. echo -e "found 'you' in documentation:\\n${yous}"
  336. exit 255
  337. fi
  338. }
  339. function markdown_marker_pass {
  340. # TODO: check other markdown files when marker handles headers with '[]'
  341. if command -v marker >/dev/null; then
  342. markerResult=$(marker --skip-http --root ./Documentation 2>&1 || true)
  343. if [ -n "${markerResult}" ]; then
  344. echo -e "marker checking failed:\\n${markerResult}"
  345. exit 255
  346. fi
  347. else
  348. echo "Skipping marker..."
  349. fi
  350. }
  351. function goword_pass {
  352. if command -v goword >/dev/null; then
  353. # get all go files to process
  354. gofiles=$(find "${FMT[@]}" -iname '*.go' 2>/dev/null)
  355. # shellcheck disable=SC2206
  356. gofiles_all=($gofiles)
  357. # ignore tests and protobuf files
  358. # shellcheck disable=SC1117
  359. gofiles=$(echo "${gofiles_all[@]}" | sort | uniq | sed "s/ /\n/g" | grep -vE "(\\_test.go|\\.pb\\.go)")
  360. # shellcheck disable=SC2206
  361. gofiles=($gofiles)
  362. # only check for broken exported godocs
  363. gowordRes=$(goword -use-spell=false "${gofiles[@]}" | grep godoc-export | sort)
  364. if [ -n "$gowordRes" ]; then
  365. echo -e "goword checking failed:\\n${gowordRes}"
  366. exit 255
  367. fi
  368. # check some spelling
  369. gowordRes=$(goword -ignore-file=.words clientv3/{*,*/*}.go 2>&1 | grep spell | sort)
  370. if [ -n "$gowordRes" ]; then
  371. echo -e "goword checking failed:\\n${gowordRes}"
  372. exit 255
  373. fi
  374. else
  375. echo "Skipping goword..."
  376. fi
  377. }
  378. function gofmt_pass {
  379. fmtRes=$(gofmt -l -s -d "${FMT[@]}")
  380. if [ -n "${fmtRes}" ]; then
  381. echo -e "gofmt checking failed:\\n${fmtRes}"
  382. exit 255
  383. fi
  384. }
  385. function govet_pass {
  386. vetRes=$(go vet "${TEST[@]}")
  387. if [ -n "${vetRes}" ]; then
  388. echo -e "govet checking failed:\\n${vetRes}"
  389. exit 255
  390. fi
  391. }
  392. function govet_shadow_pass {
  393. fmtpkgs=$(for a in "${FMT[@]}"; do dirname "$a"; done | sort | uniq | grep -v "\\.")
  394. # shellcheck disable=SC2206
  395. fmtpkgs=($fmtpkgs)
  396. # Golang 1.12 onwards the experimental -shadow option is no longer available with go vet
  397. go get golang.org/x/tools/go/analysis/passes/shadow/cmd/shadow
  398. export PATH=${GOPATH}/bin:${PATH}
  399. shadow_tool=$(which shadow)
  400. vetRes=$(go vet -all -vettool="${shadow_tool}" "${TEST[@]}")
  401. if [ -n "${vetRes}" ]; then
  402. echo -e "govet -all -shadow checking failed:\\n${vetRes}"
  403. exit 255
  404. fi
  405. }
  406. function unparam_pass {
  407. if command -v unparam >/dev/null; then
  408. unparamResult=$(unparam "${STATIC_ANALYSIS_PATHS[@]}" 2>&1 || true)
  409. if [ -n "${unparamResult}" ]; then
  410. echo -e "unparam checking failed:\\n${unparamResult}"
  411. exit 255
  412. fi
  413. else
  414. echo "Skipping unparam..."
  415. fi
  416. }
  417. function staticcheck_pass {
  418. if command -v staticcheck >/dev/null; then
  419. staticcheckResult=$(staticcheck "${STATIC_ANALYSIS_PATHS[@]}" 2>&1 || true)
  420. if [ -n "${staticcheckResult}" ]; then
  421. # TODO: resolve these after go1.8 migration
  422. # See https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck
  423. STATIC_CHECK_MASK="S(A|T)(1002|1005|1006|1008|1012|1019|1032|2002|4003|4006)"
  424. if echo "${staticcheckResult}" | grep -vE "$STATIC_CHECK_MASK"; then
  425. echo -e "staticcheck checking failed:\\n${staticcheckResult}"
  426. exit 255
  427. else
  428. suppressed=$(echo "${staticcheckResult}" | sed 's/ /\n/g' | grep "(SA" | sort | uniq -c)
  429. echo -e "staticcheck suppressed warnings:\\n${suppressed}"
  430. fi
  431. fi
  432. else
  433. echo "Skipping staticcheck..."
  434. fi
  435. }
  436. function revive_pass {
  437. if command -v revive >/dev/null; then
  438. reviveResult=$(revive -config ./tests/revive.toml -exclude "vendor/..." ./... 2>&1 || true)
  439. if [ -n "${reviveResult}" ]; then
  440. echo -e "revive checking failed:\\n${reviveResult}"
  441. exit 255
  442. fi
  443. else
  444. echo "Skipping revive..."
  445. fi
  446. }
  447. function unconvert_pass {
  448. if command -v unconvert >/dev/null; then
  449. unconvertResult=$(unconvert -v "${STATIC_ANALYSIS_PATHS[@]}" 2>&1 || true)
  450. if [ -n "${unconvertResult}" ]; then
  451. echo -e "unconvert checking failed:\\n${unconvertResult}"
  452. exit 255
  453. fi
  454. else
  455. echo "Skipping unconvert..."
  456. fi
  457. }
  458. function ineffassign_pass {
  459. if command -v ineffassign >/dev/null; then
  460. ineffassignResult=$(ineffassign "${STATIC_ANALYSIS_PATHS[@]}" 2>&1 || true)
  461. if [ -n "${ineffassignResult}" ]; then
  462. echo -e "ineffassign checking failed:\\n${ineffassignResult}"
  463. exit 255
  464. fi
  465. else
  466. echo "Skipping ineffassign..."
  467. fi
  468. }
  469. function nakedret_pass {
  470. if command -v nakedret >/dev/null; then
  471. nakedretResult=$(nakedret "${STATIC_ANALYSIS_PATHS[@]}" 2>&1 || true)
  472. if [ -n "${nakedretResult}" ]; then
  473. echo -e "nakedret checking failed:\\n${nakedretResult}"
  474. exit 255
  475. fi
  476. else
  477. echo "Skipping nakedret..."
  478. fi
  479. }
  480. function license_header_pass {
  481. licRes=""
  482. files=$(find . -type f -iname '*.go' ! -path './vendor/*' ! -path './gopath.proto/*')
  483. for file in $files; do
  484. if ! head -n3 "${file}" | grep -Eq "(Copyright|generated|GENERATED)" ; then
  485. licRes="${licRes}"$(echo -e " ${file}")
  486. fi
  487. done
  488. if [ -n "${licRes}" ]; then
  489. echo -e "license header checking failed:\\n${licRes}"
  490. exit 255
  491. fi
  492. }
  493. function receiver_name_pass {
  494. # shellcheck disable=SC1117
  495. recvs=$(grep 'func ([^*]' {*,*/*,*/*/*}.go | grep -Ev "(generated|pb/)" | tr ':' ' ' | \
  496. awk ' { print $2" "$3" "$4" "$1 }' | sed "s/[a-zA-Z\.]*go//g" | sort | uniq | \
  497. grep -Ev "(Descriptor|Proto|_)" | awk ' { print $3" "$4 } ' | sort | uniq -c | grep -v ' 1 ' | awk ' { print $2 } ')
  498. if [ -n "${recvs}" ]; then
  499. # shellcheck disable=SC2206
  500. recvs=($recvs)
  501. for recv in "${recvs[@]}"; do
  502. echo "Mismatched receiver for $recv..."
  503. grep "$recv" "${FMT[@]}" | grep 'func ('
  504. done
  505. exit 255
  506. fi
  507. }
  508. function commit_title_pass {
  509. git log --oneline "$(git merge-base HEAD master)"...HEAD | while read -r l; do
  510. commitMsg=$(echo "$l" | cut -f2- -d' ')
  511. if [[ "$commitMsg" == Merge* ]]; then
  512. # ignore "Merge pull" commits
  513. continue
  514. fi
  515. if [[ "$commitMsg" == Revert* ]]; then
  516. # ignore revert commits
  517. continue
  518. fi
  519. pkgPrefix=$(echo "$commitMsg" | cut -f1 -d':')
  520. spaceCommas=$(echo "$commitMsg" | sed 's/ /\n/g' | grep -c ',$' || echo 0)
  521. commaSpaces=$(echo "$commitMsg" | sed 's/,/\n/g' | grep -c '^ ' || echo 0)
  522. if [[ $(echo "$commitMsg" | grep -c ":..*") == 0 || "$commitMsg" == "$pkgPrefix" || "$spaceCommas" != "$commaSpaces" ]]; then
  523. echo "$l"...
  524. echo "Expected commit title format '<package>{\", \"<package>}: <description>'"
  525. echo "Got: $l"
  526. exit 255
  527. fi
  528. done
  529. }
  530. # tools gosimple,unused,staticheck,unconvert,ineffasign,nakedret
  531. # are not module-aware. See https://github.com/golang/go/issues/24661
  532. # The module-aware versions need to be used when they become available
  533. function fmt_pass {
  534. toggle_failpoints disable
  535. # TODO: add "unparam"
  536. for p in shellcheck \
  537. markdown_you \
  538. markdown_marker \
  539. goword \
  540. gofmt \
  541. govet \
  542. govet_shadow \
  543. revive \
  544. license_header \
  545. receiver_name \
  546. commit_title \
  547. ; do
  548. echo "'$p' started at $(date)"
  549. "${p}"_pass "$@"
  550. echo "'$p' completed at $(date)"
  551. done
  552. }
  553. function bom_pass {
  554. if ! command -v license-bill-of-materials >/dev/null; then
  555. return
  556. fi
  557. if [ "${GO111MODULE}" == "on" ]; then
  558. # license-bill-off-materials calls "go list std cmd" which cannot handle modules
  559. # Please see https://github.com/golang/go/issues/26924
  560. echo "Skipping license-bill-of-materials with go modules..."
  561. return
  562. fi
  563. echo "Checking bill of materials..."
  564. license-bill-of-materials \
  565. --override-file bill-of-materials.override.json \
  566. github.com/coreos/etcd github.com/coreos/etcd/etcdctl >bom-now.json || true
  567. if ! diff bill-of-materials.json bom-now.json; then
  568. echo "vendored licenses do not match given bill of materials"
  569. exit 255
  570. fi
  571. rm bom-now.json
  572. }
  573. function dep_pass {
  574. echo "Checking package dependencies..."
  575. # don't pull in etcdserver package
  576. pushd clientv3 >/dev/null
  577. badpkg="(etcdserver$|mvcc$|backend$|grpc-gateway)"
  578. deps=$(go list -f '{{ .Deps }}' | sed 's/ /\n/g' | grep -E "${badpkg}" || echo "")
  579. popd >/dev/null
  580. if [ -n "$deps" ]; then
  581. echo -e "clientv3 has masked dependencies:\\n${deps}"
  582. exit 255
  583. fi
  584. }
  585. function build_cov_pass {
  586. out="bin"
  587. if [ -n "${BINDIR}" ]; then out="${BINDIR}"; fi
  588. go test -tags cov -c -covermode=set -coverpkg="$PKGS_COMMA" -o "${out}/etcd_test"
  589. go test -tags cov -c -covermode=set -coverpkg="$PKGS_COMMA" -o "${out}/etcdctl_test" "${REPO_PATH}/etcdctl"
  590. }
  591. # fail fast on static tests
  592. function build_pass {
  593. echo "Checking build..."
  594. GO_BUILD_FLAGS="-v" etcd_build
  595. GO_BUILD_FLAGS="-v" tools_build
  596. }
  597. for pass in $PASSES; do
  598. echo "Starting '$pass' pass at $(date)"
  599. "${pass}"_pass "$@"
  600. echo "Finished '$pass' pass at $(date)"
  601. done
  602. echo "Success"